-- jpburst.vhd
--
-- Version 0.0 2001/10/30
-- adopted from pllmode_write.vhd
-- Address 428: JPBURSTREG

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY jpburst IS
    PORT(
        rst		: IN	STD_LOGIC;
        CLK		: IN	STD_LOGIC;
        phase		: IN	STD_LOGIC;
        aux1		: IN	STD_LOGIC;
        we1		: IN	STD_LOGIC;
        we2		: IN	STD_LOGIC;
        bstmax        : in   std_logic_vector(5 downto 0);
        spcmax        : in   std_logic_vector(5 downto 0);
        version         : in   std_logic;
        jpmask          : out   std_logic
	);
END jpburst;

ARCHITECTURE a OF jpburst IS

    signal header_state : std_logic;
    signal bstcount : std_logic_vector(5 downto 0);
    signal masked : std_logic;
BEGIN

-- burst counter
    process(clk)
    begin
        if(clk'event and clk='1') then
            if (phase = '1') then
                if (rst = '0') then
                    bstcount <= "000000";
                elsif ((we1 = '0' and version = '1' and aux1 = '1')
                      or (we2 = '0' and version = '0' )) then
		    if (bstcount = bstmax) then
                        bstcount <= "000000";
                    else
                        bstcount <= bstcount + 1;
                    end if;
                end if;
            else
                bstcount <= bstcount;
            end if;
        end if;
    end process;

--  JPMASK setup
    masked <=  '1' when (not (spcmax = "000000")) and ( spcmax > bstcount)
               else '0'; 
    jpmask <= masked when
             ((version = '1' and aux1 = '1') or
              (we2 = '0' and version = '0' ))
              else '1'; 
END a;











