-- convert1836.vhd
-- convert 18bit data to 36 bit data
-- Version 0.0 1999/8/27 J. Makino


-- MAKUTIL ADD_PARITY 36

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY convert1836 IS

	PORT
	(
		rst		: IN	STD_LOGIC;
		CLK		: IN	STD_LOGIC;
		CLK2		: IN	STD_LOGIC;
		din		: IN	std_logic_vector(20 downto 0);
		DOUT		: OUT 	std_logic_vector(35 downto 0);
		dsout		: OUT 	std_logic;
                rstout          : out    std_logic;
                auxout             : out    std_logic_vector(1 downto 0)
	);
	
END convert1836;

ARCHITECTURE a OF convert1836 IS


signal inreg : std_logic_vector(20 downto 0);
signal inreg2 : std_logic_vector(20 downto 0);
signal midreg : std_logic_vector(39 downto 0);
signal outreg : std_logic_vector(39 downto 0);

BEGIN


    process(clk)
    begin
        if(clk'event and clk='1') then
            inreg <= din;
            inreg2 <= inreg;
            if inreg2(18) = '1' then
                midreg(17 downto 0) <= inreg(17 downto 0);
                midreg(35 downto 18) <= inreg2(17 downto 0);
                midreg(37 downto 36) <= inreg(20 downto 19);
                midreg(39 downto 38) <= inreg2(20 downto 19);
            end if;
        end if;
    end process;
    process(clk2)
    begin
        if(clk2'event and clk2='1') then
            outreg <= midreg;
        end if;
    end process;

--    dout <= outreg(35 downto 0);
--    here, convert byte parity location.
    dout(7 downto 0) <= outreg(7 downto 0);
    dout(15 downto 8) <= outreg(16 downto 9);
    dout(23 downto 16) <= outreg(25 downto 18);
    dout(31 downto 24) <= outreg(34 downto 27);
    dout(32) <= outreg(8);
    dout(33) <= outreg(17);
    dout(34) <= outreg(26);
    dout(35) <= outreg(35);
    rstout <= outreg(36);
    dsout <= outreg(38);
    auxout(0) <= outreg(37);
    auxout(1) <= outreg(39);

END a;











