-- ijpfpga3.vhd
-- renamed from ijpfpga3 2001/12/16
-- renamed from ijpfpga 2001/5/20
-- Major changes
--   pllmodes changed to programmable 
-- renamed from jpfpga_dsp 2000/6/19
-- 
-- jpfpga_dsp
-- top level for JP/IP handler FPGA
--
-- Version 0.0 1999/8/27J. Makino
-- MAKUTIL ADD_PARITY 36
-- Version 0.1 1999/9/14 J. Makino
-- Major changes:
--   instead of output disable, input selection is added
--   enable input pin removed
--   sel    input pin added low: input0, high: input1
--
-- Version 0.2 1999/11/2 J. Makino
-- Major changes
-- wra, wrb, csa, csb REMOVED
-- nCONFIG changed to bus line 
-- 
-- Version 0.3 2000/2/28 J. Makino
-- dum_out now used as inverted (or HI) reset

-- Version 0.4 2000/4/3 J. Makino
-- File name JPFPGA_DSP
-- calculate parity with  DS included (lower two bits)
-- and output according to the previous parity error status

-- Version 0.5 2000/6/19 J. Makino
-- Use AUX1 to tell ip/jp
--
--
-- Version 0.51 2000/10/19 J. Makino
-- Sel logic inverted to take care of the (wrong) wiring
-- which wird sel input to low.
--
-- Test version 2000/11/27 J. Makino
-- generate parity inside and ignore the input parity
-- for lower two bits
-- Another test version 2000/11/30
-- pass through the partity input (ds is not attached to the parity)
LIBRARY ieee;
USE ieee.std_logic_1164.all;
-- USE ieee.std_logic_unsigned.all;

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY ijpfpga3 IS
	PORT
	(
		rst		: IN	STD_LOGIC;
		CLK		: IN	STD_LOGIC;
		CLK2		: IN	STD_LOGIC;
                sel             : in    std_logic;
		din0		: IN	std_logic_vector(20 downto 0);
		din1		: IN	std_logic_vector(20 downto 0);
                ef              : in    std_logic;
		DOUT		: OUT 	std_logic_vector(35 downto 0);
                rstout          : out    std_logic;
                rstout2         : out std_logic;
                auxout          : out    std_logic_vector(1 downto 0);
                ena             : out std_logic;
                enb             : out std_logic;
                ipdsearly         : out std_logic;
                jpdsearly         : out std_logic;
                nconfigout      : out std_logic_vector(10 downto 0);
                data0out        : out std_logic;
                dclkout         : out std_logic;
                shtdn0          : out std_logic;
                shtdn1          : out std_logic;
                dwaitout        : out std_logic;
                calcsts		: IN	STD_LOGIC;
                ledout	: out	std_logic_vector(11 downto 0);
                dindum      : in    std_logic;
                sel_con     : out   std_logic;
                ippllmode   : out   std_logic_vector(6 downto 0);
                b0pllmode   : out   std_logic_vector(6 downto 0);
                b1pllmode   : out   std_logic_vector(4 downto 0);
                g6pllmode   : out   std_logic_vector(3 downto 0)
	);
END ijpfpga3;


ARCHITECTURE a OF ijpfpga3 IS

    component utilfpga2 
        PORT(
            rst		: IN	STD_LOGIC;
            CLK		: IN	STD_LOGIC;
            we		: IN	STD_LOGIC;
            din		: IN	std_logic_vector(15 downto 0);
            calcsts		: IN	STD_LOGIC;
            ledout	: out	std_logic_vector(11 downto 0);
            dindum      : in    std_logic;
            sel_con     : out   std_logic;
            ippllmode   : out   std_logic_vector(6 downto 0);
            b0pllmode   : out   std_logic_vector(6 downto 0);
            b1pllmode   : out   std_logic_vector(4 downto 0);
            g6pllmode   : out   std_logic_vector(3 downto 0)
            );
    END component;
    
    
    component convert1836 
	PORT(
            rst		: IN	STD_LOGIC;
            CLK		: IN	STD_LOGIC;
            CLK2		: IN	STD_LOGIC;
            din		: IN	std_logic_vector(20 downto 0);
            DOUT		: OUT 	std_logic_vector(35 downto 0);
            dsout		: OUT 	std_logic;
            rstout          : out    std_logic;
            auxout             : out    std_logic_vector(1 downto 0)
            );
    end component;
    
    component fofpga_write2
        PORT(
            rst		: IN	STD_LOGIC;
            CLK		: IN	STD_LOGIC;
            we		: IN	STD_LOGIC;
            din		: IN	std_logic_vector(15 downto 0);
            nconfigout      : out   std_logic_vector(10 downto 0);
            data0out        : out   std_logic;
            dclkout         : out   std_logic
            );
    END component;

    component pllmode_write2
    PORT(
        rst		: IN	STD_LOGIC;
        CLK		: IN	STD_LOGIC;
        we		: IN	STD_LOGIC;
        din		: IN	std_logic_vector(15 downto 0);
            dindum      : in    std_logic;
        b0pllmode   : out   std_logic_vector(6 downto 0);
        b1pllmode   : out   std_logic_vector(4 downto 0)
	);
    END component;



    component chkpar10
        port(
            din : in std_logic_vector(7 downto 0);
            d0   : in std_logic;
            d1   : in std_logic;
            pout : out std_logic
            );
    end component;

    component ijp_state 
        PORT(
            CLK		: IN	STD_LOGIC;
            ijp_in		: IN	STD_LOGIC;
            ijp_out            : out   std_logic
            );
    END component;

    component  genpar8
        port(
            din : in std_logic_vector(7 downto 0);
            pout : out std_logic
            );
    end component;

    signal din_in : std_logic_vector(20 downto 0);
    signal dout_in : std_logic_vector(35 downto 0);
    signal dsout_in:	std_logic;
    signal rstout_in: std_logic;
    signal auxout_in: std_logic_vector(1 downto 0);
    signal dsinvert : std_logic;
    signal reinvert : std_logic;
    signal perror   : std_logic_vector(1 downto 0);
    signal pe       : std_logic_vector(1 downto 0);
    signal ijp_mode : std_logic;
    signal ipwe_in  : std_logic;
    signal b0plldum : std_logic_vector(6 downto 0);
    signal b1plldum : std_logic_vector(4 downto 0);
BEGIN
    din_in <= din0 when sel = '1' else din1;
    shtdn0 <= '1' when sel = '1' else '0';
    shtdn1 <= '0' when sel = '1' else '1';
    u_convert: convert1836 port map(       
        rst=>rst,
        CLK=>CLK,
        CLK2=>CLK2,
        din=>din_in,
        DOUT=>dout_in,
        dsout=>dsout_in,
        rstout=> rstout_in,
        auxout=>auxout_in);
    -- logic to test and set parity error for DS
    u_perr1: chkpar10 port map(din=>dout_in(15 downto 8), d0=>dsinvert, d1=>dout_in(33),
                               pout=>pe(1));
    u_perr0: chkpar10 port map(din=>dout_in(7 downto 0), d0=>dsinvert, d1=>dout_in(32),
                               pout=>pe(0));
    -- IP/JP selection logic
    u_ijp_state: ijp_state port map(CLK=>CLK2, ijp_in=>auxout_in(0), ijp_out=>ijp_mode);

    u_util:  utilfpga2 port map(rst=>rst,
                                CLK=>CLK2,
                                we=>ipwe_in,
                                din=>dout_in(15 downto 0),
                                calcsts=>calcsts,
                                ledout=>ledout,
                                dindum=>dindum,
                                sel_con =>sel_con,
                                ippllmode=>ippllmode,
                                b0pllmode =>b0plldum,
                                b1pllmode =>b1plldum,
                                g6pllmode =>g6pllmode
                                );

    process(clk2)
    begin
        if(clk2'event and clk2='1') then
            if (rst = '0') then
                perror <= "00";
            else
                perror <= pe;
            end if;
        end if;
    end process;

    dsinvert <= '0' when dsout_in = '1' else '1';
    ipdsearly <= '0' when ef = '1' and ijp_mode = '0' else '1';
    jpdsearly <= '0' when ef = '1' and ijp_mode = '1' else '1';

    reinvert <= ef;

    ipwe_in <= '0' when dsout_in = '0' and ijp_mode = '0' else '1';

    dout(35 downto 34) <= dout_in(35 downto 34);
    dout(33 downto 32) <= dout_in(33 downto 32);
--  Current version ignore ds stuff  2000/11/30
                                    
--    dout(33) <=  dout_in(33) xor dsout_in 
--    dout(32) <=  dout_in(32) xor dsout_in
--    The above cannot possibly correct
--    dout(33) <=  dout_in(33) xor dsinvert xor perror(1);
--    dout(32) <=  dout_in(32) xor dsinvert  xor perror(0);
--    Hmm. This still look strange, but this is what have been used
--    until 2000/11/27, also with jpfpga_dsp.
--
--    The following is the test version which ignores the input parity
--    u_genpar0 : genpar8 port map(din=>dout_in(7  downto 0),pout=>dout(32));
--    u_genpar1 : genpar8 port map(din=>dout_in(15 downto 8),pout=>dout(33));
--
--    dout(32) <= '0';
--    dout(33) <= '1';

    dout(31 downto 0) <=  dout_in(31 downto 0);
    rstout <= rstout_in;
    auxout <= auxout_in;
    ena <= dsinvert;
    enb <= reinvert;
    dwaitout <= '1';
    rstout2 <= not rstout_in;

u_fofpga_write:  fofpga_write2 port map(
            rst	=>rst,
            CLK	=>CLK2,
            we	=>ipwe_in,
            din	=>dout_in(15 downto 0),
            nconfigout =>nconfigout,
            data0out   => data0out,
            dclkout    =>dclkout );

u_pllmode_write:  pllmode_write2 port map(
            rst	=>rst,
            CLK	=>CLK2,
            we	=>ipwe_in,
            din	=>dout_in(15 downto 0),
            dindum=>dindum,
	    b0pllmode => b0pllmode,
	    b1pllmode => b1pllmode);

END a;











